/**
 * Accept ͸ 
 */

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * @author lty
 *
 */
public class AcceptSelectorMonitor extends Thread
{
    private Queue    queue    	= null;
    private Selector selector 	= null;
    private int      port     	= 9090;
    private String   name     	= "AcceptSelectorMonitor - ";
    private String host 		= "localhost";
    
    
	public AcceptSelectorMonitor(Queue queue, Selector selector, String host, int port, int index)
	{
        this.queue      = queue;
        this.selector   = selector;
        this.port       = port;
        this.host 		= host;
        setName(name + index);
        init();		
	}
	
    private void init()
    {
        try
        {
            //  ä 
            ServerSocketChannel ssc = ServerSocketChannel.open();
            ssc.configureBlocking(false);   //  

            InetSocketAddress address = new InetSocketAddress(host, port);
            ssc.socket().bind(address); //  Ʈ

            //System.out.println(getName() + " : Bound to " + address);
            
            // ACCEPT ̺Ʈ Ϳ 
            ssc.register(this.selector, SelectionKey.OP_ACCEPT);
        }
        catch(IOException e)
        {
            e.printStackTrace();
        }
    }

    public void run()
    {
        try
        {
            while(!Thread.currentThread().isInterrupted())
            {
                
                selector.select();  // blocking
                Iterator iter = selector.selectedKeys().iterator();
                
                while(iter.hasNext())
                {
                    SelectionKey key = (SelectionKey) iter.next();
                    iter.remove();

                    ServerSocketChannel readyChannel = (ServerSocketChannel) key.channel();
                    SocketChannel sc = readyChannel.accept();

                    //System.out.println(getName() + ": connection accepted from " + sc.socket().toString());

                    // Accept  óؾ   ť Ǫ
                    pushMyJob(sc);
                    //System.out.println(getName() + ": Q size " + queue.getSize(NIOEvent.ACCEPT_EVENT));
                    
                }
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    private void pushMyJob(SocketChannel sc)
    {
        Map session = new HashMap();
        session.put("SocketChannel", sc);
        Job job = new Job(NIOEvent.ACCEPT_EVENT, session);
        queue.push(job);
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		// TODO Auto-generated method stub

	}

}
