/**
 * Accept ͸ 
 * μ ǹ̰    
 */
import java.io.IOException;
import java.nio.channels.Selector;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class AcceptSelectorPool
{

	private int	    port	= 9090;
	private Queue	queue	= null;
	private String	host	= "localhost";
	private int 	size = 0;
	protected final List pool = new ArrayList();

	public AcceptSelectorPool(Queue queue)
	{
		this(queue, 1, "localhost", 9090);
	}

	public AcceptSelectorPool(Queue queue, int size, String host, int port)
	{
		this.size = size;
		this.queue = queue;
		this.port = port;
		this.host = host;
		init();
	}

	private void init()
	{
		for(int i = 0; i < size; i++)
		{
			pool.add(createHandler(i));
		}
	}

	protected Thread createHandler(int index)
	{
		Selector selector = null;
		try
		{
			selector = Selector.open();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
		Thread handler = new AcceptSelectorMonitor(queue, selector, host, port, index);

		return handler;
	}

	public void startAll()
	{
		Iterator iter = pool.iterator();
		while(iter.hasNext())
		{
			Thread handler = (Thread) iter.next();
			handler.start();
		}
	}

	public void stopAll()
	{
		Iterator iter = pool.iterator();
		while(iter.hasNext())
		{
			Thread handler = (Thread) iter.next();
			handler.interrupt();
			handler = null;
		}
	}

}
