
/**
 * AcceptWorker Thread Ѵ.
 */

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author lty
 *
 */
public class AcceptWorkerPool
{
	private int	         max	    = 10;
	private int	         min	    = 2;
	private int	         current	= 0;

	private final Object	monitor	= new Object();
	private final List	 pool	    = new ArrayList();

	private Queue	     queue	    = null;

	public AcceptWorkerPool(Queue queue)
	{
		this(queue, 2, 10);
	}

	public AcceptWorkerPool(Queue queue, int min, int max)
	{
		this.queue = queue;
		this.min = min;
		this.max = max;
		init();
	}

	/*
	 * Worder 带 
	 */
	private void init()
	{
		for(int i = 0; i < min; i++)
		{
			pool.add(createThread(i));
		}
	}

	private synchronized Thread createThread(int index)
	{
		Thread thread = null;
		try
		{
			thread = new AcceptWorker(queue, index);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		current++;
		return thread;
	}

	public void startAll()
	{
		synchronized (monitor)
		{
			Iterator iter = pool.iterator();
			while(iter.hasNext())
			{
				Thread thread = (Thread) iter.next();
				thread.start();
			}
		}
	}

	public void stopAll()
	{
		synchronized (monitor)
		{
			Iterator iter = pool.iterator();
			while(iter.hasNext())
			{
				Thread thread = (Thread) iter.next();
				thread.interrupt();
				thread = null;
			}
			pool.clear();
		}
	}

	public void addThread()
	{
		synchronized (monitor)
		{
			if(current < max)
			{
				Thread t = createThread(current);
				t.start();
				pool.add(t);
			}
		}
	}

	public void removeThread()
	{
		synchronized (monitor)
		{
			if(current > min)
			{
				Thread t = (Thread) pool.remove(0);
				t.interrupt();
				t = null;
			}
		}
	}
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		// TODO Auto-generated method stub

	}

}
