
import java.io.IOException;

public class VMServer
{

	private Queue	       queue	            = null;
	private AcceptSelectorPool	acceptSelectorPool	= null;
	private ReadSelectorPool	readSelectorPool	= null;
	// public static URLInfoList urlInfo = null;
	// public static VMLogger g_vmLog = new VMLogger("VMServer.log");

	ThreadPool	       readThreadPool	    = null;
	AcceptWorkerPool	acceptWorkerPool = null;

	public VMServer()
	{
		try
		{
			// initConfig();
			initResource();
			startServer();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}

	/*
	 * private void initConfig() { urlInfo = URLInfoList.getInstance();
	 * //urlInfo = URLInfoList.getInstance("configurl.xml"); }
	 */
	private void initResource() throws IOException
	{

		// Queue ..
		queue = BlockingEventQueue.getInstance();

		// ThreadPool ..
		acceptWorkerPool = new AcceptWorkerPool(queue);
		readThreadPool = new ThreadPool(queue);

		// SelectorPool ..
		acceptSelectorPool = new AcceptSelectorPool(queue, 1, "localhost", 9090);
		readSelectorPool = ReadSelectorPool.getInstance(queue);

	}

	private void startServer()
	{
		acceptWorkerPool.startAll();
		readThreadPool.startAll();

		acceptSelectorPool.startAll();
		readSelectorPool.startAll();
	}

	public static void main(String[] args)
	{
		VMServer server = new VMServer();
	}

}
